# UC TaxCloud

## Installation

- [Register for a TaxCloud merchant
  account](https://taxcloud.com/account/register/)
- [Register for a USPS account
  ID](https://secure.shippingapis.com/registration)
  Follow the steps on the email you'll receive to set this USPS account for
  production usage, or call USPS support. This module won't work if USPS
  account is not on production mode. This account is used to verify addresses.
- [Install this module as usual](https://drupal.org/node/70151). This module
  requires the following modules from Ubercart: Taxes, Store, Order


## Configuration

- Configure TIC Field for product classes: 
  - Go to Structure > Content Types > Product > Manage Fields
    (`admin/structure/types/manage/product/fields`)
  - Add a TIC Code field. Machine name MUST be `field_tic_code` of type "Text"
    with "Text field" widget. Set as non-required, set default value to `00000`
    and Maximum length 255
  - Repeat steps above for each product class of your store. Suggestion: use
    "Add existing field" for each class once you added the field for the first
    time. You can set different default value for TIC code on each class. See
    https://taxcloud.com/tic for more information.
- Go to Store > Configuration > TaxCloud settings:
  (`admin/store/settings/uc_taxcloud`)
  - Set Default Taxability Information Code for store (this is a global setting,
    just in case not each product has tic configured).
     See https://taxcloud.com/tic for more information.
  - Set Shipping Taxability Information Code. This is the TIC applied to
    shipping. (The standard shipping TIC is 11010)
     See https://taxcloud.com/tic for more information.
  - Set TaxCloud API ID, API Key and USPS ID from steps 1, 2
     See https://taxcloud.com/account/api/ for more information
  - Set Delivered by seller option (1 = seller's vehicle, 0 = other method i.e
    UPS, FedEx, etc)
- Configure Store address:
  - Go to Store > Configuration > Store > Store Address
    (`admin/store/settings/store`)
  - Set all the fields with valid information.
- (Optional) Activate TaxCloud cart pane:
  - Go to Store > Configuration > Cart (`admin/store/settings/cart`).
  - This will let your users to have pre-calculated taxes before checkout.
  - Note: On cart pane, shipping taxes are not calculated.
- (Optional) Configure TIC codes for your products: Edit your products. You'll
  find the TIC code field you configured on step #4 on "Product Information"
  section where SKU is. The text field interface will be replaced automatically
  with TaxCloud's TIC code selector. (Javascript enabled required)
- Test your configuration by adding some products to the cart and setting real
  delivery (shipping) addresses on checkout page. You'll find a "Taxes" line
  item with tax lookup amount. It's recommended that you enable error displaying
  on `admin/config/development/logging` for tests. That will show you valuable
  information if lookup cannot be done for some reason.

  Important: On production sites, you must not show lookup errors to user
  (`admin/config/development/logging`) as they may contain sensitive data.
