<?php

/**
 * @file
 * Individual classes for various TaxCloud data structures.
 * @license https://taxcloud.net/ftpsl.pdf
 */

/**
 * Defines an address for use with Taxcloud.
 */
class Address {

  private $Address1;

  private $Address2;

  private $City;

  private $State;

  private $Zip5;

  private $Zip4;

  /**
   *
   */
  public function __construct() {
  }

  /**
   *
   */
  public function setAddress1($address1) {
    $this->Address1 = $address1;
  }

  /**
   *
   */
  public function getAddress1() {
    return $this->Address1;
  }

  /**
   *
   */
  public function setAddress2($address2) {
    $this->Address2 = $address2;
  }

  /**
   *
   */
  public function getAddress2() {
    return $this->Address2;
  }

  /**
   *
   */
  public function setCity($city) {
    $this->City = $city;
  }

  /**
   *
   */
  public function getCity() {
    return $this->City;
  }

  /**
   *
   */
  public function setState($state) {
    $this->State = $state;
  }

  /**
   *
   */
  public function getState() {
    return $this->State;
  }

  /**
   *
   */
  public function setZip5($zip5) {
    $this->Zip5 = $zip5;
  }

  /**
   *
   */
  public function getZip5() {
    return $this->Zip5;
  }

  /**
   *
   */
  public function setZip4($zip4) {
    $this->Zip4 = $zip4;
  }

  /**
   *
   */
  public function getZip4() {
    return $this->Zip4;
  }

}

/**
 * Manage business types for use with Taxcloud.
 */
class BusinessType {

  public static $AccommodationAndFoodServices = "AccommodationAndFoodServices";
  public static $Agricultural_Forestry_Fishing_Hunting = "Agricultural_Forestry_Fishing_Hunting";
  public static $Construction = "Construction";
  public static $FinanceAndInsurance = "FinanceAndInsurance";
  public static $Information_PublishingAndCommunications = "Information_PublishingAndCommunications";
  public static $Manufacturing = "Manufacturing";
  public static $Mining = "Mining";
  public static $RealEstate = "RealEstate";
  public static $RentalAndLeasing = "RentalAndLeasing";
  public static $RetailTrade = "RetailTrade";
  public static $TransportationAndWarehousing = "TransportationAndWarehousing";
  public static $Utilities = "Utilities";
  public static $WholesaleTrade = "WholesaleTrade";
  public static $BusinessServices = "BusinessServices";
  public static $ProfessionalServices = "ProfessionalServices";
  public static $EducationAndHealthCareServices = "EducationAndHealthCareServices";
  public static $NonprofitOrganization = "NonprofitOrganization";
  public static $Government = "Government";
  public static $NotABusiness = "NotABusiness";
  public static $Other = "Other";

  private $Value;

  /**
   *
   */
  public function __construct($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function setValue($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function getValue() {
    return $this->Value;
  }

  /**
   *
   */
  public function __toString() {
    return "Other";
  }

}

/**
 * Represents an item added to the cart.
 */
class CartItem {

  private $ItemID;

  private $Index;

  private $TIC;

  private $Price;

  private $Qty;

  /**
   *
   */
  public function __construct() {
  }

  /**
   *
   */
  public function setItemID($itemID) {
    $this->ItemID = $itemID;
  }

  /**
   *
   */
  public function getItemID() {
    return $this->ItemID;
  }

  /**
   *
   */
  public function setIndex($index) {
    $this->Index = $index;
  }

  /**
   *
   */
  public function getIndex() {
    return $this->Index;
  }

  /**
   *
   */
  public function setTIC($TIC) {
    $this->TIC = $TIC;
  }

  /**
   *
   */
  public function getTIC() {
    return $this->TIC;
  }

  /**
   *
   */
  public function setPrice($price) {
    $this->Price = $price;
  }

  /**
   *
   */
  public function getPrice() {
    return $this->Price;
  }

  /**
   *
   */
  public function setQty($qty) {
    $this->Qty = $qty;
  }

  /**
   *
   */
  public function getQty() {
    return $this->Qty;
  }

}

/**
 * Represents an exemption certificate.
 */
class ExemptionCertificate {

  private $CertificateID;

  private $Detail;

  /**
   *
   */
  public function __construct() {
  }

  /**
   *
   */
  public function setCertificateID($certificateID) {
    $this->CertificateID = $certificateID;
  }

  /**
   *
   */
  public function getCertificateID() {
    return $this->CertificateID;
  }

  /**
   *
   */
  public function setDetail($exemptionCertificateDetail) {
    $this->Detail = $exemptionCertificateDetail;
  }

  /**
   *
   */
  public function getDetail() {
    return $this->Detail;
  }

}

/**
 * Represents the details on an exemption certificate.
 */
class ExemptionCertificateDetail {

  private $ExemptStates = array();

  private $SinglePurchase;

  private $SinglePurchaseOrderNumber;

  private $PurchaserFirstName;

  private $PurchaserLastName;

  private $PurchaserTitle;

  private $PurchaserAddress1;

  private $PurchaserAddress2;

  private $PurchaserCity;

  private $PurchaserState;

  private $PurchaserZip;

  private $PurchaserTaxID;

  private $PurchaserBusinessType;

  private $PurchaserBusinessTypeOtherValue;

  private $PurchaserExemptionReason;

  private $PurchaserExemptionReasonValue;

  private $CreatedDate;

  /**
   *
   */
  public function __construct() {
  }

  /**
   *
   */
  public function setExemptStates($exemptStates) {
    $this->ExemptStates = $exemptStates;
  }

  /**
   *
   */
  public function getExemptStates() {
    return $this->ExemptStates;
  }

  /**
   *
   */
  public function setSinglePurchase($singlePurchase) {
    $this->SinglePurchase = $singlePurchase;
  }

  /**
   *
   */
  public function getSinglePurchase() {
    return $this->SinglePurchase;
  }

  /**
   *
   */
  public function setSinglePurchaseOrderNumber($singlePurchaseOrderNumber) {
    $this->SinglePurchaseOrderNumber = $singlePurchaseOrderNumber;
  }

  /**
   *
   */
  public function getSinglePurchaseOrderNumber() {
    return $this->SinglePurchaseOrderNumber;
  }

  /**
   *
   */
  public function setPurchaserFirstName($purchaserFirstName) {
    $this->PurchaserFirstName = $purchaserFirstName;
  }

  /**
   *
   */
  public function getPurchaserFirstName() {
    return $this->PurchaserFirstName;
  }

  /**
   *
   */
  public function setPurchaserLastName($purchaserLastName) {
    $this->PurchaserLastName = $purchaserLastName;
  }

  /**
   *
   */
  public function getPurchaserLastName() {
    return $this->PurchaserLastName;
  }

  /**
   *
   */
  public function setPurchaserTitle($purchaserTitle) {
    $this->PurchaserTitle = $purchaserTitle;
  }

  /**
   *
   */
  public function getPurchaserTitle() {
    return $this->PurchaserTitle;
  }

  /**
   *
   */
  public function setPurchaserAddress1($purchaserAddress1) {
    $this->PurchaserAddress1 = $purchaserAddress1;
  }

  /**
   *
   */
  public function getPurchaserAddress1() {
    return $this->PurchaserAddress1;
  }

  /**
   *
   */
  public function setPurchaserCity($purchaserCity) {
    $this->PurchaserCity = $purchaserCity;
  }

  /**
   *
   */
  public function getPurchaserCity() {
    return $this->PurchaserCity;
  }

  /**
   *
   */
  public function setPurchaserState($purchaserState) {
    $this->PurchaserState = $purchaserState;
  }

  /**
   *
   */
  public function getPurchaserState() {
    return $this->PurchaserState;
  }

  /**
   *
   */
  public function setPurchaserZip($purchaserZip) {
    $this->PurchaserZip = $purchaserZip;
  }

  /**
   *
   */
  public function getPurchaserZip() {
    return $this->PurchaserZip;
  }

  /**
   *
   */
  public function setPurchaserTaxID($purchaserTaxID) {
    $this->PurchaserTaxID = $purchaserTaxID;
  }

  /**
   *
   */
  public function getPurchaserTaxID() {
    return $this->PurchaserTaxID;
  }

  /**
   *
   */
  public function setPurchaserBusinessType($purchaserBusinessType) {
    $this->PurchaserBusinessType = $purchaserBusinessType;
  }

  /**
   *
   */
  public function getPurchaserBusinessType() {
    return $this->PurchaserBusinessType;
  }

  /**
   *
   */
  public function setPurchaserBusinessTypeOtherValue($purchaserBusinessTypeOtherValue) {
    $this->PurchaserBusinessTypeOtherValue = $purchaserBusinessTypeOtherValue;
  }

  /**
   *
   */
  public function getPurchaserBusinessTypeOtherValue() {
    return $this->PurchaserBusinessTypeOtherValue;
  }

  /**
   *
   */
  public function setPurchaserExemptionReason($purchaserExemptionReason) {
    $this->PurchaserExemptionReason = $purchaserExemptionReason;
  }

  /**
   *
   */
  public function getPurchaserExemptionReason() {
    return $this->PurchaserExemptionReason;
  }

  /**
   *
   */
  public function setPurchaserExemptionReasonValue($purchaserExemptionReasonValue) {
    $this->PurchaserExemptionReasonValue = $purchaserExemptionReasonValue;
  }

  /**
   *
   */
  public function addExemptState($exemptState) {

    $index = sizeof($this->ExemptStates);
    // print("<br><br>addExemptState - index: ");
    //    print_r($index);
    $this->ExemptStates[$index] = $exemptState;
  }

  /**
   *
   */
  public function setCreatedDate($createdDate) {
    $this->CreatedDate = $createdDate;
  }

  /**
   *
   */
  public function getCreatedDate() {
    return $this->CreatedDate;
  }

}

/**
 * Represents the reason used for an exemption.
 */
class ExemptionReason {

  public static $FederalGovernmentDepartment = "FederalGovernmentDepartment";
  public static $StateOrLocalGovernmentName = "StateOrLocalGovernmentName";
  public static $TribalGovernmentName = "TribalGovernmentName";
  public static $ForeignDiplomat = "ForeignDiplomat";
  public static $CharitableOrganization = "CharitableOrganization";
  public static $ReligiousOrEducationalOrganization = "ReligiousOrEducationalOrganization";
  public static $Resale = "Resale";
  public static $AgriculturalProduction = "AgriculturalProduction";
  public static $IndustrialProductionOrManufacturing = "IndustrialProductionOrManufacturing";
  public static $DirectPayPermit = "DirectPayPermit";
  public static $DirectMail = "DirectMail";
  public static $Other = "Other";

  /**
   *
   */
  public function __construct($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function setValue($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function getValue() {
    return $this->Value;
  }

  /**
   *
   */
  public function __toString() {
    return "Other";
  }

}

/**
 * Represents the state of an individual exemption.
 */
class ExemptState {

  private $StateAbbr;

  private $ReasonForExemption;

  private $IdentificationNumber;

  /**
   *
   */
  public function __construct($stateAbbr, $reasonForExemption, $identificationNumber) {
    $this->StateAbbr = $stateAbbr;
    $this->ReasonForExemption = $reasonForExemption;
    $this->IdentificationNumber = $identificationNumber;
  }

  /**
   *
   */
  public function setStateAbbr($stateAbbr) {
    $this->StateAbbr = $stateAbbr;
  }

  /**
   *
   */
  public function getStateAbbr() {
    return $this->StateAbbr;
  }

  /**
   *
   */
  public function setReasonForExemption($reasonForExemption) {
    $this->ReasonForExemption = $reasonForExemption;
  }

  /**
   *
   */
  public function getReasonForExemption() {
    return $this->ReasonForExemption;
  }

  /**
   *
   */
  public function setIdentificationNumber($identificationNumber) {
    $this->IdentificationNumber = $identificationNumber;
  }

  /**
   *
   */
  public function getIdentificationNumber() {
    return $this->IdentificationNumber;
  }

}

/**
 * Represents US states.
 */
class State {

  public static $AL = "AL";
  public static $AK = "AK";
  public static $AZ = "AZ";
  public static $AR = "AR";
  public static $CA = "CA";
  public static $CO = "CO";
  public static $CT = "CT";
  public static $DE = "DE";
  public static $DC = "DC";
  public static $FL = "FL";
  public static $GA = "GA";
  public static $HI = "HI";
  public static $ID = "ID";
  public static $IL = "IL";
  public static $IN = "IN";
  public static $IA = "IA";
  public static $KS = "KS";
  public static $KY = "KY";
  public static $LA = "LA";
  public static $ME = "ME";
  public static $MD = "MD";
  public static $MA = "MA";
  public static $MI = "MI";
  public static $MN = "MN";
  public static $MS = "MS";
  public static $MO = "MO";
  public static $MT = "MT";
  public static $NE = "NE";
  public static $NV = "NV";
  public static $NH = "NH";
  public static $NJ = "NJ";
  public static $NM = "NM";
  public static $NY = "NY";
  public static $NC = "NC";
  public static $ND = "ND";
  public static $OH = "OH";
  public static $OK = "OK";
  public static $OR = "OR";
  public static $PA = "PA";
  public static $RI = "RI";
  public static $SC = "SC";
  public static $SD = "SD";
  public static $TN = "TN";
  public static $TX = "TX";
  public static $UT = "UT";
  public static $VT = "VT";
  public static $VA = "VA";
  public static $WA = "WA";
  public static $WV = "WV";
  public static $WI = "WI";
  public static $WY = "WY";

  private $Value;

  /**
   *
   */
  public function __construct($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function setValue($value) {
    $this->Value = $value;
  }

  /**
   *
   */
  public function getValue() {
    return $this->Value;
  }

}

/**
 * Represents a tax ID.
 */
class TaxID {

  private $TaxType;

  private $IDNumber;

  private $StateOfIssue;

  /**
   *
   */
  public function __construct($taxType = NULL, $idNumber = NULL, $stateOfIssue = NULL) {
    $this->TaxType = $taxType;
    $this->IDNumber = $idNumber;
    $this->StateOfIssue = $stateOfIssue;
  }

  /**
   *
   */
  public function setTaxType($taxIDType) {
    $this->TaxType = $taxIDType;
  }

  /**
   *
   */
  public function getTaxType() {
    return $this->TaxType;
  }

  /**
   *
   */
  public function setIDNumber($idNumber) {
    $this->IDNumber = $idNumber;
  }

  /**
   *
   */
  public function getIDNumber() {
    return $this->IDNumber;
  }

  /**
   *
   */
  public function setStateOfIssue($stateOfIssue) {
    $this->StateOfIssue = $stateOfIssue;
  }

  /**
   *
   */
  public function getStateOfIssue() {
    return $this->StateOfIssue;
  }

}

/**
 * Represents a TIC item.
 */
class TIC {

  private $TICID;

  private $Description;

  /**
   *
   */
  public function __construct($ticID, $description) {
    $this->TICID = $ticID;
    $this->Description = $description;
  }

  /**
   *
   */
  public function setTICID($ticID) {
    $this->TICID = $ticID;
  }

  /**
   *
   */
  public function getTICID() {
    return $this->TICID;
  }

  /**
   *
   */
  public function setDescription() {
    $this->Description = description;
  }

  /**
   *
   */
  public function getDescription() {
    return $this->Description;
  }

}

/**
 * Represents a TIC group.
 */
class TICGroup {

  private $GroupID;
  private $Description;

  /**
   *
   */
  public function __construct($groupID, $description) {
    $this->GroupID = $groupID;
    $this->Description = $description;
  }

  /**
   *
   */
  public function setGroupID($groupID) {
    $this->GroupID = $groupID;
  }

  /**
   *
   */
  public function getGroupID() {
    return $this->GroupID;
  }

  /**
   *
   */
  public function setDescription($description) {
    $this->Description = $description;
  }

  /**
   *
   */
  public function getDescription() {
    return $this->Description;
  }

}

/**
 * Represents an address that was verified.
 */
class VerifiedAddress {

  private $ErrNumber;
  private $ErrDescription;

  /**
   *
   */
  public function __construct() {
  }

  /**
   *
   */
  public function setErrNumber($errNumber) {
    $this->ErrNumber = $errNumber;
  }

  /**
   *
   */
  public function getErrNumber() {
    return $this->ErrNumber;
  }

  /**
   *
   */
  public function setErrDescription($errDescription) {
    $this->ErrDescription = $errDescription;
  }

  /**
   *
   */
  public function getErrDescription() {
    return $this->ErrDescrption;
  }

}

/**
 * Represents a Paypal token used to correlate customers.
 *
 * This class is used for the Express Checkout process to correlate
 * PayPal tokens to customers.
 */
class TokenHash {

  /**
   *
   */
  private function __construct() {
    // Load serialized data, if any.
    include "classarm *.log.inc";

    $s = file_get_contents('hashstore');
    if (isset($s)) {
      self::$hash = unserialize($s);
    }
    $this->removeOldHashItems();
  }

  /**
   *
   */
  public static function getInstance() {
    if (self::$instance == NULL) {
      self::$instance = new TokenHash();
    }
    return self::$instance;
  }

  /**
   *
   */
  public function AddToken($customerID, $token, $cartID) {
    $now = time();
    self::$hash[] = array($token, $customerID, $cartID, $now);

    // Serialize data.
    $s = serialize(self::$hash);
    file_put_contents('store', $s);
  }

  /**
   *
   */
  public function removeToken($token) {

    foreach (self::$hash as $id => $storedValues) {
      $storedToken = $storedValues[0];
      if ($token == $storedToken) {
        unset(self::$hash[$id]);
        $s = serialize(self::$hash);
        file_put_contents('store', $s);

      }
    }
  }

  /**
   *
   */
  public function getCustomerID($token) {
    foreach (self::$hash as $id => $storedValues) {
      $storedToken = $storedValues[0];
      if ($token == $storedToken) {
        return $storedValues[1];
      }
    }
    return 0;
  }

  /**
   *
   */
  public function getCartID($token) {
    foreach (self::$hash as $id => $storedValues) {
      $storedToken = $storedValues[0];
      if ($token == $storedToken) {
        return $storedValues[2];
      }
    }
    return 0;
  }

  /**
   *
   */
  public function removeOldHashItems() {
    $aWeekAgo = time() - (7 * 24 * 60 * 60);
    foreach (self::$hash as $item) {
      $hashTime = $item[3];
      if ($hashTime < $aWeekAgo) {
        $this->removeToken($item[0]);
      }

    }

  }

  static private $instance = NULL;
  static private $hash = array();

}
